assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRAOGroup")
local roster = AceLibrary("Roster-2.1")
local playergroup = 0

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["Group"] = true,
	["group"] = true,
	["groupoptional"] = true,
	["Optional/Group"] = true,
	["Options for Group."] = true,
	["%s has joined your group."] = true,
	["%s has left your group."] = true,
	["You have joined group %d."] = true,
	["change"] = true,
	["Group Change"] = true,
	["Notify for group change."] = true,
	["members"] = true,
	["Members Change"] = true,
	["Notify for group members change."] = true,
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

oRAOGroup = oRA:NewModule(L["groupoptional"])
oRAOGroup.defaults = {
	change = true,
	members = true,
}
oRAOGroup.optional = true
oRAOGroup.name = L["Optional/Group"]
oRAOGroup.consoleCmd = L["group"]
oRAOGroup.consoleOptions = {
	type = "group",
	desc = L["Options for Group."],
	name = L["Group"],
	disabled = function() return not oRA:IsActive() end,	
	args = {
		[L["change"]] = {
			type = "toggle", name = L["Group Change"],
			desc = L["Notify for group change."],
			get = function() return not oRAOGroup.db.profile.change end,
			set = function(v) oRAOGroup.db.profile.change = v end,
		},
		[L["members"]] = {
			type = "toggle", name = L["Members Change"],
			desc = L["Notify for group members change."],
			get = function() return not oRAOGroup.db.profile.members end,
			set = function(v) oRAOGroup.db.profile.members = v end,
		},
	}
}

------------------------------
--      Initialization      --
------------------------------

function oRAOGroup:OnEnable()
	local playerunit = roster:GetUnitObjectFromName(UnitName("player"))
	playergroup = playerunit.subgroup or 0
	self:RegisterEvent("RosterLib_UnitChanged")
end

------------------------
--   Event Handlers   --
------------------------

function oRAOGroup:RosterLib_UnitChanged( id, name, class, subgroup, rank, oldname, oldid, oldclass, oldsubgroup, oldrank )
	if subgroup ~= oldsubgroup then
		if UnitName("player") == name then
			playergroup = subgroup
			self:Print( string.format( L["You are now in group %d."], playergroup )
		elseif oldsubgroup == playergroup then
			self:Print( string.format( L["%s has left your group."], name )
		elseif subgroup == playergroup then
			self:Print( string.format( L["%s has joined your group."], name )
		end
	end
end
